#include <stdlib.h>
#include <string.h>
#include "memchunk.h"

#define	TRUE	(-1)
#define	FALSE	0

/* initialize chunk	-----------------------------------------------------*/
void chunk_init(MemChunk * chunk, int size)
{
	chunk->array = NULL;
	chunk->size = size;
	chunk->total = 0;
	chunk->index = 0;
}

/* free chunk	-------------------------------------------------------------*/
void chunk_free(MemChunk * chunk)
{
	if (chunk->array != NULL) {
		free(chunk->array);
		chunk->array = NULL;
	}
	chunk->total = 0;
	chunk->index = 0;
}

/* clear chunk for reuse	---------------------------------------------*/
void chunk_clear(MemChunk * chunk)
{
	chunk->index = 0;
}

/* reallocate chunk area	---------------------------------------------*/
void *myrealloc(void *ptr, int size)
{
	void *p;

	if ((p = realloc(ptr, size)) == NULL) {
		free(ptr);
	}
	return (p);
}

/* remember in array	-----------------------------------------------------*/
int chunk_add(MemChunk * mem, const void *p)
{
	if (mem->index < mem->total) {
		memcpy((char *) mem->array + (mem->index++) * mem->size, p,
		       mem->size);
		return (TRUE);
	} else if (mem->total == 0) {
		mem->total = 128;
		if ((mem->array = malloc(mem->total * mem->size)) == NULL) {
			return (FALSE);
		}
		memcpy(mem->array, p, mem->size);
		mem->index = 1;
		return (TRUE);
	}

	mem->total *= 2;
	if ((mem->array = myrealloc(mem->array,
				    mem->total * mem->size)) == NULL) {
		mem->total = mem->index = 0;
		return (FALSE);
	}
	memcpy((char *) mem->array + (mem->index++) * mem->size, p,
	       mem->size);
	return (TRUE);
}
/*	End Of File	******************************************************/
